DayTimeMoneyHud = {};
DayTimeMoneyHud.metadata = {
	interface = " FS19 ...",
	title = " DayTimeMoney Hud",
	notes = " setzt GameDay/RealDay/RealTime+Color+Size etc. zusätzlich/mit ins DayTimeMoney Hud",
	author = " (by HappyLooser)",
	version = " v0.2 Beta",	
	datum = " 20.11.2018",
	update = " 02.12.2018",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

DayTimeMoneyHud.accepts = {"rhms(realHour:realMin:realSec), rhm(realHour:realMin), rHour(realHour), rMin(realMin), rSec(realSec), rWeekday(realWeekDay), rday(realDay), rMonth(realMonth), rYear(realYear)"};
DayTimeMoneyHud.accepts1 = {"iWeekday(inGameWeekDay), iPlaytime(inGamePlayTime), iPlayday(inGamePlayDay), iMoney(inGameMoney), iHelperOnOff(inGameHelperOnOff), iHelperOn(inGameHelperOn), iHelperOff(inGameHelperOff), iForwardTime(inGameForwardTime), freetxt_HERE TEXT(setFreeText)"};
DayTimeMoneyHud.BSP = {"langother1,iplayday,freetxt_ (,iweekday,freetxt_)         					SEE ---> Spieltag: XX (Montag) 			--- Spieltag: is language.other value, so langother1"};
DayTimeMoneyHud.BSP1 = {"rhms,freetxt_ ,rweekday,freetxt_ ,rday,freetxt_.,rmonth        			SEE ---> 19:22:45 Montag 18.November 	--- Montag and November is language.weekday and language.month value"};
DayTimeMoneyHud.notActive = {"iPlaytime(inGamePlayTime), iMoney(inGameMoney), iHelperOnOff(inGameHelperOnOff), iHelperOn(inGameHelperOn), iHelperOff(inGameHelperOff)"};

function DayTimeMoneyHud:loadMap(name)
	g_currentMission.dayTimeMoneyHud = DayTimeMoneyHud;
	print("---loading".. tostring(DayTimeMoneyHud.metadata.title).. tostring(DayTimeMoneyHud.metadata.version).. tostring(DayTimeMoneyHud.metadata.author).. "---")
	if g_server ~= nil and g_client == nil then return;end;
	DayTimeMoneyHud.settingsDir = getUserProfileAppPath().. "modsSettings/DayTimeMoneyHud/";	
	DayTimeMoneyHud.rebootXml = true;
	DayTimeMoneyHud.timeFormat = 24;
	DayTimeMoneyHud.diffPosY = 0.002;
	DayTimeMoneyHud.diffPosX = 0.002;
	DayTimeMoneyHud.foundForwardTimeString = 0;
	DayTimeMoneyHud.position = {};
	DayTimeMoneyHud.position[1] = {setTextColorR=1.0, setTextColorG=1.0, setTextColorB=1.0, setTextColorA=1.0, setTextAlignment=0, setString="freetxt_Pos 1", setTextBold=false, setTextSize=0.010, setPosX=0.8, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0};
	DayTimeMoneyHud.position[2] = {setTextColorR=1.0, setTextColorG=1.0, setTextColorB=1.0, setTextColorA=1.0, setTextAlignment=0, setString="freetxt_Pos 2", setTextBold=false, setTextSize=0.010, setPosX=1.0, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0};
	DayTimeMoneyHud.position[3] = {setTextColorR=1.0, setTextColorG=1.0, setTextColorB=1.0, setTextColorA=1.0, setTextAlignment=0, setString="freetxt_Pos 3", setTextBold=false, setTextSize=0.010, setPosX=1.0, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0};
	DayTimeMoneyHud.position[4] = {setTextColorR=1.0, setTextColorG=1.0, setTextColorB=1.0, setTextColorA=1.0, setTextAlignment=0, setString="freetxt_Pos 4", setTextBold=false, setTextSize=0.010, setPosX=1.0, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0};
	DayTimeMoneyHud.position[5] = {setTextColorR=1.0, setTextColorG=1.0, setTextColorB=1.0, setTextColorA=1.0, setTextAlignment=0, setString="langother1,iplayday,freetxt_ (,iweekday,freetxt_)", setTextBold=true, setTextSize=0.010, setPosX=1.0, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0};
	DayTimeMoneyHud.position[6] = {setTextColorR=1.0, setTextColorG=1.0, setTextColorB=1.0, setTextColorA=1.0, setTextAlignment=0, setString="freetxt_Pos 6", setTextBold=false, setTextSize=0.010, setPosX=1.0, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0}; ---ForwardTime Default !!!
	DayTimeMoneyHud.position[7] = {setTextColorR=1.0, setTextColorG=1.0, setTextColorB=1.0, setTextColorA=1.0, setTextAlignment=0, setString="freetxt_Pos 7", setTextBold=false, setTextSize=0.010, setPosX=1.0, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0};
	DayTimeMoneyHud.position[8] = {setTextColorR=0.015686, setTextColorG=1.0, setTextColorB=0.0, setTextColorA=1.0, setTextAlignment=0, setString="rhms,freetxt_ ,rweekday,freetxt_ ,rday,freetxt_.,rmonth", setTextBold=false, setTextSize=0.010, setPosX=1.0, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0};
	DayTimeMoneyHud.position[9] = {setTextColorR=1.0, setTextColorG=1, setTextColorB=1.0, setTextColorA=1.0, setTextAlignment=0, setString="langother4,iforwardtime", setTextBold=true, setTextSize=0.010, setPosX=1.0, setFixPosX=0.0, setPosY=1.0, setFixPosY=0.0, lastTextWidth=0, lastTextHeight=0, lastTextPosX=0};
	DayTimeMoneyHud.money = {true, 0.010, true};
	DayTimeMoneyHud.moneyColor = {1, 1, 1, 1};
	DayTimeMoneyHud.inGameTime = {true, 0.010, true};	
	DayTimeMoneyHud.inGameTimeColor = {1, 1, 1, 1};
	DayTimeMoneyHud.forwardTime = {true, 0.010, true};
	DayTimeMoneyHud.forwardTimeColor = {1.000000, 1.000000, 0.000000, 1};
	DayTimeMoneyHud.inGame = nil;
	DayTimeMoneyHud:getInGameDisplay();
	DayTimeMoneyHud.language = {};
	DayTimeMoneyHud.language.weekday = {"Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag"};
	DayTimeMoneyHud.language.month = {"Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"};
	DayTimeMoneyHud.language.other = {"Spieltag:", "Geld:", "Helfer:", "ZeitRaffer >> ", "Spielzeit:"};
	if DayTimeMoneyHud.inGame ~= nil and DayTimeMoneyHud.inGame.timeTextSize ~= nil then DayTimeMoneyHud.inGameTime[2] = DayTimeMoneyHud.inGame.timeTextSize;end;	
	DayTimeMoneyHud:setGetCfg(true);	
end;

function DayTimeMoneyHud:deleteMap()
	if g_server ~= nil and g_client == nil then return;end;
	DayTimeMoneyHud:setGetCfg(false);	
end;

function DayTimeMoneyHud:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DayTimeMoneyHud:keyEvent(unicode, sym, modifier, isDown)
	if g_server ~= nil and g_client == nil then return;end;
	if DayTimeMoneyHud.rebootXml and Input.isKeyPressed(Input.KEY_esc) then
		if g_currentMission.inGameMenu.isOpen then DayTimeMoneyHud:setGetCfg(true);end;		
	end;
end;

function DayTimeMoneyHud:update(dt)
end;

function DayTimeMoneyHud:draw(dt)
	if g_server ~= nil and g_client == nil then return;end;	
	for a = 1, 4 do
		if string.len(DayTimeMoneyHud.position[a].setString) > 0 then
			setTextBold(Utils.getNoNil(DayTimeMoneyHud.position[a].setTextBold, false));			
			setTextAlignment(0);
			local color = {Utils.getNoNil(DayTimeMoneyHud.position[a].setTextColorR, 1),Utils.getNoNil(DayTimeMoneyHud.position[a].setTextColorG, 1),Utils.getNoNil(DayTimeMoneyHud.position[a].setTextColorB, 1),Utils.getNoNil(DayTimeMoneyHud.position[a].setTextColorA, 1)};
			if DayTimeMoneyHud.foundForwardTimeString == a then color = DayTimeMoneyHud.forwardTimeColor;end;
			setTextColor(unpack(color));
			local size = Utils.getNoNil(DayTimeMoneyHud.position[a].setTextSize, 0.010);
			local setStringUnformat = Utils.getNoNil(DayTimeMoneyHud.position[a].setString, "Unknown");
			local setString = DayTimeMoneyHud:getStringFormat(setStringUnformat, a)	
			local txtHeight = getTextHeight(size, setString);
			local txtWidth = getTextWidth(size, setString);
			DayTimeMoneyHud.position[a].lastTextWidth = txtWidth;
			DayTimeMoneyHud.position[a].lastTextHeight = txtHeight;
			local textAlignment = Utils.getNoNil(DayTimeMoneyHud.position[a].setTextAlignment, 0);			
			local setPosX = 0.5;
			local setPosY = 1.0-(txtHeight)-(DayTimeMoneyHud.diffPosY);
			if a > 1 and DayTimeMoneyHud.position[a].setPosX >= 1.0 then setPosX = DayTimeMoneyHud.position[a-1].lastPosX+DayTimeMoneyHud.position[a-1].lastTextWidth+DayTimeMoneyHud.diffPosX;end;
			if DayTimeMoneyHud.position[a].setPosX < 1.0 then setPosX = DayTimeMoneyHud.position[a].setPosX;end;
			if DayTimeMoneyHud.position[a].setPosY < 1.0 then setPosY = DayTimeMoneyHud.position[a].setPosY;end;
			DayTimeMoneyHud.position[a].lastPosX = setPosX+DayTimeMoneyHud.position[a].setFixPosX;
			if textAlignment == 0 then
				renderText(setPosX+DayTimeMoneyHud.position[a].setFixPosX, setPosY+DayTimeMoneyHud.position[a].setFixPosY, size, tostring(setString));
			elseif textAlignment == 1 then
				renderText(setPosX+DayTimeMoneyHud.position[a].setFixPosX-(txtWidth/2), setPosY+DayTimeMoneyHud.position[a].setFixPosY, size, tostring(setString));
			elseif textAlignment == 2 then
				renderText(setPosX+DayTimeMoneyHud.position[a].setFixPos-txtWidth, setPosY+DayTimeMoneyHud.position[a].setFixPosY, size, tostring(setString));
			end;
		end;
	end;
	if string.len(DayTimeMoneyHud.position[5].setString) > 0 then
		setTextBold(Utils.getNoNil(DayTimeMoneyHud.position[5].setTextBold, false));
		setTextAlignment(0);
		local color = {Utils.getNoNil(DayTimeMoneyHud.position[5].setTextColorR, 1),Utils.getNoNil(DayTimeMoneyHud.position[5].setTextColorG, 1),Utils.getNoNil(DayTimeMoneyHud.position[5].setTextColorB, 1),Utils.getNoNil(DayTimeMoneyHud.position[5].setTextColorA, 1)};
		if DayTimeMoneyHud.foundForwardTimeString == 5 then color = DayTimeMoneyHud.forwardTimeColor;end;
		setTextColor(unpack(color));
		local size = Utils.getNoNil(DayTimeMoneyHud.position[5].setTextSize, 0.010);
		local setStringUnformat = Utils.getNoNil(DayTimeMoneyHud.position[5].setString, "Unknown");
		local setString = DayTimeMoneyHud:getStringFormat(setStringUnformat, 5)	
		local txtHeight = getTextHeight(size, setString);
		local txtWidth = getTextWidth(size, setString);
		DayTimeMoneyHud.position[5].lastTextWidth = txtWidth;
		DayTimeMoneyHud.position[5].lastTextHeight = txtHeight;		
		local textAlignment = Utils.getNoNil(DayTimeMoneyHud.position[5].setTextAlignment, 0);
		local setPosX = DayTimeMoneyHud.inGame.weatherBox.overlay.x+(DayTimeMoneyHud.inGame.weatherBox.overlay.width/2);
		local setPosY = DayTimeMoneyHud.inGame.weatherBox.overlay.y+DayTimeMoneyHud.inGame.weatherBox.overlay.height-(DayTimeMoneyHud.diffPosY);		
		if DayTimeMoneyHud.position[5].setPosX < 1.0 then setPosX = DayTimeMoneyHud.position[5].setPosX;end;
		if DayTimeMoneyHud.position[5].setPosY < 1.0 then setPosY = DayTimeMoneyHud.position[5].setPosY;end;
		DayTimeMoneyHud.position[5].lastPosX = setPosX+DayTimeMoneyHud.position[5].setFixPosX;
		if textAlignment == 0 then
			renderText(setPosX+DayTimeMoneyHud.position[5].setFixPosX, setPosY+DayTimeMoneyHud.position[5].setFixPosY, size, tostring(setString));
		elseif textAlignment == 1 then
			renderText(setPosX+DayTimeMoneyHud.position[5].setFixPosX-(txtWidth/2), setPosY+DayTimeMoneyHud.position[5].setFixPosY, size, tostring(setString));
		elseif textAlignment == 2 then
			renderText(setPosX+DayTimeMoneyHud.position[5].setFixPosX-txtWidth, setPosY+DayTimeMoneyHud.position[5].setFixPosY, size, tostring(setString));
		end;
	end;
	if string.len(DayTimeMoneyHud.position[6].setString) > 0 then
		setTextBold(Utils.getNoNil(DayTimeMoneyHud.position[6].setTextBold, false));
		setTextAlignment(0);
		local color = {Utils.getNoNil(DayTimeMoneyHud.position[6].setTextColorR, 1),Utils.getNoNil(DayTimeMoneyHud.position[6].setTextColorG, 1),Utils.getNoNil(DayTimeMoneyHud.position[6].setTextColorB, 1),Utils.getNoNil(DayTimeMoneyHud.position[6].setTextColorA, 1)};
		if DayTimeMoneyHud.foundForwardTimeString == 6 then color = DayTimeMoneyHud.forwardTimeColor;end;
		setTextColor(unpack(color));
		local size = Utils.getNoNil(DayTimeMoneyHud.position[6].setTextSize, 0.010);
		local setStringUnformat = Utils.getNoNil(DayTimeMoneyHud.position[6].setString, "Unknown");
		local setString = DayTimeMoneyHud:getStringFormat(setStringUnformat, 6)	
		local txtHeight = getTextHeight(size, setString);
		local txtWidth = getTextWidth(size, setString);
		DayTimeMoneyHud.position[6].lastTextWidth = txtWidth;
		DayTimeMoneyHud.position[6].lastTextHeight = txtHeight;		
		local textAlignment = Utils.getNoNil(DayTimeMoneyHud.position[6].setTextAlignment, 0);
		local setPosX = DayTimeMoneyHud.inGame.timeBox.overlay.x+(DayTimeMoneyHud.inGame.timeBox.overlay.width)-txtWidth-DayTimeMoneyHud.diffPosX;
		local setPosY = DayTimeMoneyHud.inGame.timeBox.overlay.y+DayTimeMoneyHud.inGame.timeBox.overlay.height-(DayTimeMoneyHud.diffPosY);		
		if DayTimeMoneyHud.position[6].setPosX < 1.0 then setPosX = DayTimeMoneyHud.position[6].setPosX;end;
		if DayTimeMoneyHud.position[6].setPosY < 1.0 then setPosY = DayTimeMoneyHud.position[6].setPosY;end;
		DayTimeMoneyHud.position[6].lastPosX = setPosX+DayTimeMoneyHud.position[6].setFixPosX;
		if textAlignment == 0 then
			renderText(setPosX+DayTimeMoneyHud.position[6].setFixPosX, setPosY+DayTimeMoneyHud.position[6].setFixPosY, size, tostring(setString));		
		elseif textAlignment == 1 then
			renderText(setPosX+DayTimeMoneyHud.position[6].setFixPosX-(txtWidth/2), setPosY+DayTimeMoneyHud.position[6].setFixPosY, size, tostring(setString));
		elseif textAlignment == 2 then
			renderText(setPosX+DayTimeMoneyHud.position[6].setFixPosX-txtWidth, setPosY+DayTimeMoneyHud.position[6].setFixPosY, size, tostring(setString));
		end;
	end;
	if string.len(DayTimeMoneyHud.position[7].setString) > 0 then
		setTextBold(Utils.getNoNil(DayTimeMoneyHud.position[7].setTextBold, false));
		setTextAlignment(0);
		local color = {Utils.getNoNil(DayTimeMoneyHud.position[7].setTextColorR, 1),Utils.getNoNil(DayTimeMoneyHud.position[7].setTextColorG, 1),Utils.getNoNil(DayTimeMoneyHud.position[7].setTextColorB, 1),Utils.getNoNil(DayTimeMoneyHud.position[7].setTextColorA, 1)};
		if DayTimeMoneyHud.foundForwardTimeString == 7 then color = DayTimeMoneyHud.forwardTimeColor;end;
		setTextColor(unpack(color));
		local size = Utils.getNoNil(DayTimeMoneyHud.position[7].setTextSize, 0.010);
		local setStringUnformat = Utils.getNoNil(DayTimeMoneyHud.position[7].setString, "Unknown");
		local setString = DayTimeMoneyHud:getStringFormat(setStringUnformat, 7)	
		local txtHeight = getTextHeight(size, setString);
		local txtWidth = getTextWidth(size, setString);
		DayTimeMoneyHud.position[7].lastTextWidth = txtWidth;
		DayTimeMoneyHud.position[7].lastTextHeight = txtHeight;		
		local textAlignment = Utils.getNoNil(DayTimeMoneyHud.position[7].setTextAlignment, 0);
		local setPosX = DayTimeMoneyHud.inGame.moneyBox.overlay.x+(DayTimeMoneyHud.inGame.moneyBox.overlay.width)-txtWidth-DayTimeMoneyHud.diffPosX;
		local setPosY = DayTimeMoneyHud.inGame.moneyBox.overlay.y+DayTimeMoneyHud.inGame.moneyBox.overlay.height-(DayTimeMoneyHud.diffPosY);		
		if DayTimeMoneyHud.position[7].setPosX < 1.0 then setPosX = DayTimeMoneyHud.position[7].setPosX;end;
		if DayTimeMoneyHud.position[7].setPosY < 1.0 then setPosY = DayTimeMoneyHud.position[7].setPosY;end;
		DayTimeMoneyHud.position[7].lastPosX = setPosX+DayTimeMoneyHud.position[7].setFixPosX;
		if textAlignment == 0 then
			renderText(setPosX+DayTimeMoneyHud.position[7].setFixPosX, setPosY+DayTimeMoneyHud.position[7].setFixPosY, size, tostring(setString));		
		elseif textAlignment == 1 then
			renderText(setPosX+DayTimeMoneyHud.position[7].setFixPosX-(txtWidth/2), setPosY+DayTimeMoneyHud.position[7].setFixPosY, size, tostring(setString));
		elseif textAlignment == 2 then
			renderText(setPosX+DayTimeMoneyHud.position[7].setFixPosX-txtWidth, setPosY+DayTimeMoneyHud.position[7].setFixPosY, size, tostring(setString));
		end;
	end;
	if string.len(DayTimeMoneyHud.position[8].setString) > 0 then
		setTextBold(Utils.getNoNil(DayTimeMoneyHud.position[8].setTextBold, false));
		setTextAlignment(0);
		local color = {Utils.getNoNil(DayTimeMoneyHud.position[8].setTextColorR, 1),Utils.getNoNil(DayTimeMoneyHud.position[8].setTextColorG, 1),Utils.getNoNil(DayTimeMoneyHud.position[8].setTextColorB, 1),Utils.getNoNil(DayTimeMoneyHud.position[8].setTextColorA, 1)};
		if DayTimeMoneyHud.foundForwardTimeString == 8 then color = DayTimeMoneyHud.forwardTimeColor;end;
		setTextColor(unpack(color));
		local size = Utils.getNoNil(DayTimeMoneyHud.position[8].setTextSize, 0.010);
		local setStringUnformat = Utils.getNoNil(DayTimeMoneyHud.position[8].setString, "Unknown");
		local setString = DayTimeMoneyHud:getStringFormat(setStringUnformat, 8)	
		local txtHeight = getTextHeight(size, setString);
		local txtWidth = getTextWidth(size, setString);
		DayTimeMoneyHud.position[8].lastTextWidth = txtWidth;
		DayTimeMoneyHud.position[8].lastTextHeight = txtHeight;		
		local textAlignment = Utils.getNoNil(DayTimeMoneyHud.position[8].setTextAlignment, 0);
		local setPosX = DayTimeMoneyHud.inGame.weatherBox.overlay.x+(DayTimeMoneyHud.inGame.weatherBox.overlay.width/2);
		local setPosY = DayTimeMoneyHud.inGame.weatherBox.overlay.y-(txtHeight/2)-(DayTimeMoneyHud.diffPosY);		
		if DayTimeMoneyHud.position[8].setPosX < 1.0 then setPosX = DayTimeMoneyHud.position[8].setPosX;end;
		if DayTimeMoneyHud.position[8].setPosY < 1.0 then setPosY = DayTimeMoneyHud.position[8].setPosY;end;
		DayTimeMoneyHud.position[8].lastPosX = setPosX+DayTimeMoneyHud.position[8].setFixPosX;
		if textAlignment == 0 then
			renderText(setPosX+DayTimeMoneyHud.position[8].setFixPosX, setPosY+DayTimeMoneyHud.position[8].setFixPosY, size, tostring(setString));		
		elseif textAlignment == 1 then
			renderText(setPosX+DayTimeMoneyHud.position[8].setFixPosX-(txtWidth/2), setPosY+DayTimeMoneyHud.position[8].setFixPosY, size, tostring(setString));
		elseif textAlignment == 2 then
			renderText(setPosX+DayTimeMoneyHud.position[8].setFixPosX-txtWidth, setPosY+DayTimeMoneyHud.position[8].setFixPosY, size, tostring(setString));
		end;
	end;
	if string.len(DayTimeMoneyHud.position[9].setString) > 0 then
		setTextBold(Utils.getNoNil(DayTimeMoneyHud.position[9].setTextBold, false));
		setTextAlignment(0);
		local color = {Utils.getNoNil(DayTimeMoneyHud.position[9].setTextColorR, 1),Utils.getNoNil(DayTimeMoneyHud.position[9].setTextColorG, 1),Utils.getNoNil(DayTimeMoneyHud.position[9].setTextColorB, 1),Utils.getNoNil(DayTimeMoneyHud.position[9].setTextColorA, 1)};
		if DayTimeMoneyHud.foundForwardTimeString == 9 then color = DayTimeMoneyHud.forwardTimeColor;end;
		setTextColor(unpack(color));
		local size = Utils.getNoNil(DayTimeMoneyHud.position[9].setTextSize, 0.010);
		local setStringUnformat = Utils.getNoNil(DayTimeMoneyHud.position[9].setString, "Unknown");
		local setString = DayTimeMoneyHud:getStringFormat(setStringUnformat, 9)	
		local txtHeight = getTextHeight(size, setString);
		local txtWidth = getTextWidth(size, setString);
		DayTimeMoneyHud.position[9].lastTextWidth = txtWidth;
		DayTimeMoneyHud.position[9].lastTextHeight = txtHeight;		
		local textAlignment = Utils.getNoNil(DayTimeMoneyHud.position[9].setTextAlignment, 0);
		local setPosX = DayTimeMoneyHud.inGame.moneyBox.overlay.x+(DayTimeMoneyHud.inGame.moneyBox.overlay.width)-txtWidth-DayTimeMoneyHud.diffPosX;
		local setPosY = DayTimeMoneyHud.inGame.moneyBox.overlay.y-(txtHeight/2)-(DayTimeMoneyHud.diffPosY);		
		if DayTimeMoneyHud.position[9].setPosX < 1.0 then setPosX = DayTimeMoneyHud.position[9].setPosX;end;
		if DayTimeMoneyHud.position[9].setPosY < 1.0 then setPosY = DayTimeMoneyHud.position[9].setPosY;end;
		DayTimeMoneyHud.position[9].lastPosX = setPosX+DayTimeMoneyHud.position[9].setFixPosX;
		if textAlignment == 0 then
			renderText(setPosX+DayTimeMoneyHud.position[9].setFixPosX, setPosY+DayTimeMoneyHud.position[9].setFixPosY, size, tostring(setString));		
		elseif textAlignment == 1 then
			renderText(setPosX+DayTimeMoneyHud.position[9].setFixPosX-(txtWidth/2), setPosY+DayTimeMoneyHud.position[9].setFixPosY, size, tostring(setString));
		elseif textAlignment == 2 then
			renderText(setPosX+DayTimeMoneyHud.position[9].setFixPosX-txtWidth, setPosY+DayTimeMoneyHud.position[9].setFixPosY, size, tostring(setString));
		end;
	end;	
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(DayTimeMoneyHud);

function DayTimeMoneyHud:getProzentString(fill, capacity)	
	return string.format("%1.0f", "".. tonumber(fill)/tonumber(capacity)*100);
end;

function DayTimeMoneyHud:setGetCfg(loadCfg)
	createFolder(getUserProfileAppPath().. "modsSettings/");
	createFolder(DayTimeMoneyHud.settingsDir);
	local file = DayTimeMoneyHud.settingsDir.. "dayTimeMoneyHudSettings.xml";
	local Xml = nil;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("DayTimeMoneyHud_XML", file, "dayTimeMoneyHudSettings");
		local groupNameTag = ("dayTimeMoneyHudSettings.help.accepts(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#setString", DayTimeMoneyHud.accepts[1]);
		groupNameTag = ("dayTimeMoneyHudSettings.help.accepts1(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#setString", DayTimeMoneyHud.accepts1[1]);
		groupNameTag = ("dayTimeMoneyHudSettings.help.notActive(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#setString", DayTimeMoneyHud.notActive[1]);
		groupNameTag = ("dayTimeMoneyHudSettings.help.bsp(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#setString", DayTimeMoneyHud.BSP[1]);
		groupNameTag = ("dayTimeMoneyHudSettings.help.bsp1(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#setString", DayTimeMoneyHud.BSP1[1]);
		groupNameTag = ("dayTimeMoneyHudSettings.help.attention(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#value", "Global rebootXmlESC is for testing, set false is testing end");
		
		groupNameTag = ("dayTimeMoneyHudSettings.global(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#rebootXmlESC", DayTimeMoneyHud.rebootXml);
		setXMLInt(Xml, groupNameTag.. "#timeFormat", DayTimeMoneyHud.timeFormat);
				
		groupNameTag = ("dayTimeMoneyHudSettings.money(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#money", DayTimeMoneyHud.money[1]);
		setXMLFloat(Xml, groupNameTag.. "#size", DayTimeMoneyHud.money[2]);
		setXMLBool(Xml, groupNameTag.. "#bold", DayTimeMoneyHud.money[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorR", DayTimeMoneyHud.moneyColor[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", DayTimeMoneyHud.moneyColor[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", DayTimeMoneyHud.moneyColor[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", DayTimeMoneyHud.moneyColor[4]);
		
		groupNameTag = ("dayTimeMoneyHudSettings.forwardTime(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#forwardTime", DayTimeMoneyHud.forwardTime[1]);
		setXMLFloat(Xml, groupNameTag.. "#size", DayTimeMoneyHud.forwardTime[2]);
		setXMLBool(Xml, groupNameTag.. "#bold", DayTimeMoneyHud.forwardTime[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorR", DayTimeMoneyHud.forwardTimeColor[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", DayTimeMoneyHud.forwardTimeColor[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", DayTimeMoneyHud.forwardTimeColor[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", DayTimeMoneyHud.forwardTimeColor[4]);
		
		groupNameTag = ("dayTimeMoneyHudSettings.inGameTime(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#inGameTime", DayTimeMoneyHud.inGameTime[1]);
		setXMLFloat(Xml, groupNameTag.. "#size", DayTimeMoneyHud.inGameTime[2]);
		setXMLBool(Xml, groupNameTag.. "#bold", DayTimeMoneyHud.inGameTime[3]);	
		setXMLFloat(Xml, groupNameTag.. "#colorR", DayTimeMoneyHud.inGameTimeColor[1]);
		setXMLFloat(Xml, groupNameTag.. "#colorG", DayTimeMoneyHud.inGameTimeColor[2]);
		setXMLFloat(Xml, groupNameTag.. "#colorB", DayTimeMoneyHud.inGameTimeColor[3]);
		setXMLFloat(Xml, groupNameTag.. "#colorA", DayTimeMoneyHud.inGameTimeColor[4]);
				
		groupNameTag = ("dayTimeMoneyHudSettings.language.weekday(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#day1", DayTimeMoneyHud.language.weekday[1]);
		setXMLString(Xml, groupNameTag.. "#day2", DayTimeMoneyHud.language.weekday[2]);
		setXMLString(Xml, groupNameTag.. "#day3", DayTimeMoneyHud.language.weekday[3]);
		setXMLString(Xml, groupNameTag.. "#day4", DayTimeMoneyHud.language.weekday[4]);
		setXMLString(Xml, groupNameTag.. "#day5", DayTimeMoneyHud.language.weekday[5]);
		setXMLString(Xml, groupNameTag.. "#day6", DayTimeMoneyHud.language.weekday[6]);
		setXMLString(Xml, groupNameTag.. "#day7", DayTimeMoneyHud.language.weekday[7]);
		
		groupNameTag = ("dayTimeMoneyHudSettings.language.month(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#month1", DayTimeMoneyHud.language.month[1]);
		setXMLString(Xml, groupNameTag.. "#month2", DayTimeMoneyHud.language.month[2]);
		setXMLString(Xml, groupNameTag.. "#month3", DayTimeMoneyHud.language.month[3]);
		setXMLString(Xml, groupNameTag.. "#month4", DayTimeMoneyHud.language.month[4]);
		setXMLString(Xml, groupNameTag.. "#month5", DayTimeMoneyHud.language.month[5]);
		setXMLString(Xml, groupNameTag.. "#month6", DayTimeMoneyHud.language.month[6]);
		setXMLString(Xml, groupNameTag.. "#month7", DayTimeMoneyHud.language.month[7]);
		setXMLString(Xml, groupNameTag.. "#month8", DayTimeMoneyHud.language.month[8]);
		setXMLString(Xml, groupNameTag.. "#month9", DayTimeMoneyHud.language.month[9]);
		setXMLString(Xml, groupNameTag.. "#month10", DayTimeMoneyHud.language.month[10]);
		setXMLString(Xml, groupNameTag.. "#month11", DayTimeMoneyHud.language.month[11]);
		setXMLString(Xml, groupNameTag.. "#month12", DayTimeMoneyHud.language.month[12]);
		
		groupNameTag = ("dayTimeMoneyHudSettings.language.other(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#other1", DayTimeMoneyHud.language.other[1]);
		setXMLString(Xml, groupNameTag.. "#other2", DayTimeMoneyHud.language.other[2]);
		setXMLString(Xml, groupNameTag.. "#other3", DayTimeMoneyHud.language.other[3]);
		setXMLString(Xml, groupNameTag.. "#other4", DayTimeMoneyHud.language.other[4]);
		setXMLString(Xml, groupNameTag.. "#other5", DayTimeMoneyHud.language.other[5]);
		
		for a=1, 9 do
			groupNameTag = ("dayTimeMoneyHudSettings.position.pos".. tostring(a)); --.. "(%d)"):format(a-1);			
			setXMLFloat(Xml, groupNameTag.. "#setTextColorR", DayTimeMoneyHud.position[a].setTextColorR);
			setXMLFloat(Xml, groupNameTag.. "#setTextColorG", DayTimeMoneyHud.position[a].setTextColorG);
			setXMLFloat(Xml, groupNameTag.. "#setTextColorB", DayTimeMoneyHud.position[a].setTextColorB);
			setXMLFloat(Xml, groupNameTag.. "#setTextColorA", DayTimeMoneyHud.position[a].setTextColorA);
			setXMLInt(Xml, groupNameTag.. "#setTextAlignment", DayTimeMoneyHud.position[a].setTextAlignment);
			setXMLBool(Xml, groupNameTag.. "#setTextBold", DayTimeMoneyHud.position[a].setTextBold);
			setXMLString(Xml, groupNameTag.. "#setString", DayTimeMoneyHud.position[a].setString);
			setXMLFloat(Xml, groupNameTag.. "#setTextSize", DayTimeMoneyHud.position[a].setTextSize);
			setXMLFloat(Xml, groupNameTag.. "#setPosX", DayTimeMoneyHud.position[a].setPosX);
			setXMLFloat(Xml, groupNameTag.. "#setFixPosX", DayTimeMoneyHud.position[a].setFixPosX);
			setXMLFloat(Xml, groupNameTag.. "#setPosY", DayTimeMoneyHud.position[a].setPosY);
			setXMLFloat(Xml, groupNameTag.. "#setFixPosY", DayTimeMoneyHud.position[a].setFixPosY);			
		end;
		saveXMLFile(Xml);
	else	
		Xml = loadXMLFile("DayTimeMoneyHud_XML", file, "DayTimeMoneyHudSettings");
		local groupNameTag = ("dayTimeMoneyHudSettings.global(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#rebootXmlESC") ~= nil then DayTimeMoneyHud.rebootXml = getXMLBool(Xml, groupNameTag.. "#rebootXmlESC");end;
		if getXMLInt(Xml, groupNameTag.. "#timeFormat") then DayTimeMoneyHud.timeFormat = getXMLInt(Xml, groupNameTag.. "#timeFormat");end;
		if DayTimeMoneyHud.timeFormat > 24 or DayTimeMoneyHud.timeFormat < 12 then DayTimeMoneyHud.timeFormat = 24;end;
		
		groupNameTag = ("dayTimeMoneyHudSettings.money(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#money") ~= nil then DayTimeMoneyHud.money[1] = getXMLBool(Xml, groupNameTag.. "#money");end;
		if getXMLFloat(Xml, groupNameTag.. "#size") then DayTimeMoneyHud.money[2] = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLBool(Xml, groupNameTag.. "#bold") ~= nil then DayTimeMoneyHud.money[3] = getXMLBool(Xml, groupNameTag.. "#bold");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then DayTimeMoneyHud.moneyColor[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then DayTimeMoneyHud.moneyColor[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then DayTimeMoneyHud.moneyColor[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then DayTimeMoneyHud.moneyColor[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		
		groupNameTag = ("dayTimeMoneyHudSettings.forwardTime(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#forwardTime") ~= nil then DayTimeMoneyHud.forwardTime[1] = getXMLBool(Xml, groupNameTag.. "#forwardTime");end;
		if getXMLFloat(Xml, groupNameTag.. "#size") then DayTimeMoneyHud.forwardTime[2] = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLBool(Xml, groupNameTag.. "#bold") ~= nil then DayTimeMoneyHud.forwardTime[3] = getXMLBool(Xml, groupNameTag.. "#bold");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then DayTimeMoneyHud.forwardTimeColor[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then DayTimeMoneyHud.forwardTimeColor[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then DayTimeMoneyHud.forwardTimeColor[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then DayTimeMoneyHud.forwardTimeColor[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
		
		groupNameTag = ("dayTimeMoneyHudSettings.inGameTime(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#inGameTime") ~= nil then DayTimeMoneyHud.inGameTime[1] = getXMLBool(Xml, groupNameTag.. "#inGameTime");end;		
		if getXMLFloat(Xml, groupNameTag.. "#size") then DayTimeMoneyHud.inGameTime[2] = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLBool(Xml, groupNameTag.. "#bold") ~= nil then DayTimeMoneyHud.inGameTime[3] = getXMLBool(Xml, groupNameTag.. "#bold");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorR") then DayTimeMoneyHud.inGameTimeColor[1] = getXMLFloat(Xml, groupNameTag.. "#colorR");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorG") then DayTimeMoneyHud.inGameTimeColor[2] = getXMLFloat(Xml, groupNameTag.. "#colorG");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorB") then DayTimeMoneyHud.inGameTimeColor[3] = getXMLFloat(Xml, groupNameTag.. "#colorB");end;
		if getXMLFloat(Xml, groupNameTag.. "#colorA") then DayTimeMoneyHud.inGameTimeColor[4] = getXMLFloat(Xml, groupNameTag.. "#colorA");end;
				
		groupNameTag = ("dayTimeMoneyHudSettings.language.weekday(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#day1") ~= nil then DayTimeMoneyHud.language.weekday[1] = getXMLString(Xml, groupNameTag.. "#day1");end;
		if getXMLString(Xml, groupNameTag.. "#day2") ~= nil then DayTimeMoneyHud.language.weekday[2] = getXMLString(Xml, groupNameTag.. "#day2");end;
		if getXMLString(Xml, groupNameTag.. "#day3") ~= nil then DayTimeMoneyHud.language.weekday[3] = getXMLString(Xml, groupNameTag.. "#day3");end;
		if getXMLString(Xml, groupNameTag.. "#day4") ~= nil then DayTimeMoneyHud.language.weekday[4] = getXMLString(Xml, groupNameTag.. "#day4");end;
		if getXMLString(Xml, groupNameTag.. "#day5") ~= nil then DayTimeMoneyHud.language.weekday[5] = getXMLString(Xml, groupNameTag.. "#day5");end;
		if getXMLString(Xml, groupNameTag.. "#day6") ~= nil then DayTimeMoneyHud.language.weekday[6] = getXMLString(Xml, groupNameTag.. "#day6");end;
		if getXMLString(Xml, groupNameTag.. "#day7") ~= nil then DayTimeMoneyHud.language.weekday[7] = getXMLString(Xml, groupNameTag.. "#day7");end;
				
		groupNameTag = ("dayTimeMoneyHudSettings.language.month(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#month1") ~= nil then DayTimeMoneyHud.language.month[1] = getXMLString(Xml, groupNameTag.. "#month1");end;
		if getXMLString(Xml, groupNameTag.. "#month2") ~= nil then DayTimeMoneyHud.language.month[2] = getXMLString(Xml, groupNameTag.. "#month2");end;
		if getXMLString(Xml, groupNameTag.. "#month3") ~= nil then DayTimeMoneyHud.language.month[3] = getXMLString(Xml, groupNameTag.. "#month3");end;
		if getXMLString(Xml, groupNameTag.. "#month4") ~= nil then DayTimeMoneyHud.language.month[4] = getXMLString(Xml, groupNameTag.. "#month4");end;
		if getXMLString(Xml, groupNameTag.. "#month5") ~= nil then DayTimeMoneyHud.language.month[5] = getXMLString(Xml, groupNameTag.. "#month5");end;
		if getXMLString(Xml, groupNameTag.. "#month6") ~= nil then DayTimeMoneyHud.language.month[6] = getXMLString(Xml, groupNameTag.. "#month6");end;
		if getXMLString(Xml, groupNameTag.. "#month7") ~= nil then DayTimeMoneyHud.language.month[7] = getXMLString(Xml, groupNameTag.. "#month7");end;
		if getXMLString(Xml, groupNameTag.. "#month8") ~= nil then DayTimeMoneyHud.language.month[8] = getXMLString(Xml, groupNameTag.. "#month8");end;
		if getXMLString(Xml, groupNameTag.. "#month9") ~= nil then DayTimeMoneyHud.language.month[9] = getXMLString(Xml, groupNameTag.. "#month9");end;
		if getXMLString(Xml, groupNameTag.. "#month10") ~= nil then DayTimeMoneyHud.language.month[10] = getXMLString(Xml, groupNameTag.. "#month10");end;
		if getXMLString(Xml, groupNameTag.. "#month11") ~= nil then DayTimeMoneyHud.language.month[11] = getXMLString(Xml, groupNameTag.. "#month11");end;
		if getXMLString(Xml, groupNameTag.. "#month12") ~= nil then DayTimeMoneyHud.language.month[12] = getXMLString(Xml, groupNameTag.. "#month12");end;
				
		groupNameTag = ("dayTimeMoneyHudSettings.language.other(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#other1") ~= nil then DayTimeMoneyHud.language.other[1] = getXMLString(Xml, groupNameTag.. "#other1");end;
		if getXMLString(Xml, groupNameTag.. "#other2") ~= nil then DayTimeMoneyHud.language.other[2] = getXMLString(Xml, groupNameTag.. "#other2");end;
		if getXMLString(Xml, groupNameTag.. "#other3") ~= nil then DayTimeMoneyHud.language.other[3] = getXMLString(Xml, groupNameTag.. "#other3");end;
		if getXMLString(Xml, groupNameTag.. "#other4") ~= nil then DayTimeMoneyHud.language.other[4] = getXMLString(Xml, groupNameTag.. "#other4");end;
		if getXMLString(Xml, groupNameTag.. "#other5") ~= nil then DayTimeMoneyHud.language.other[5] = getXMLString(Xml, groupNameTag.. "#other5");end;	
				
		for a=1, 9 do
			groupNameTag = ("dayTimeMoneyHudSettings.position.pos".. tostring(a)); --.. "(%d)"):format(a-1);
			if groupNameTag == nil then break;end;
			if getXMLFloat(Xml, groupNameTag.. "#setTextColorR") then DayTimeMoneyHud.position[a].setTextColorR = getXMLFloat(Xml, groupNameTag.. "#setTextColorR");end;
			if getXMLFloat(Xml, groupNameTag.. "#setTextColorG") then DayTimeMoneyHud.position[a].setTextColorG = getXMLFloat(Xml, groupNameTag.. "#setTextColorG");end;
			if getXMLFloat(Xml, groupNameTag.. "#setTextColorB") then DayTimeMoneyHud.position[a].setTextColorB = getXMLFloat(Xml, groupNameTag.. "#setTextColorB");end;
			if getXMLFloat(Xml, groupNameTag.. "#setTextColorA") then DayTimeMoneyHud.position[a].setTextColorA = getXMLFloat(Xml, groupNameTag.. "#setTextColorA");end;			
			if getXMLString(Xml, groupNameTag.. "#setString") ~= nil then DayTimeMoneyHud.position[a].setString = getXMLString(Xml, groupNameTag.. "#setString");end;
			if getXMLBool(Xml, groupNameTag.. "#setTextBold") ~= nil then DayTimeMoneyHud.position[a].setTextBold = getXMLBool(Xml, groupNameTag.. "#setTextBold");end;
			if getXMLFloat(Xml, groupNameTag.. "#setTextSize") then DayTimeMoneyHud.position[a].setTextSize = getXMLFloat(Xml, groupNameTag.. "#setTextSize");end;
			if getXMLInt(Xml, groupNameTag.. "#setTextAlignment") then DayTimeMoneyHud.position[a].setTextAlignment = getXMLInt(Xml, groupNameTag.. "#setTextAlignment");end;
			if getXMLFloat(Xml, groupNameTag.. "#setFixPosX") then DayTimeMoneyHud.position[a].setFixPosX = getXMLFloat(Xml, groupNameTag.. "#setFixPosX");end;
			if getXMLFloat(Xml, groupNameTag.. "#setFixPosY") then DayTimeMoneyHud.position[a].setFixPosY = getXMLFloat(Xml, groupNameTag.. "#setFixPosY");end;
			if DayTimeMoneyHud.position[a].setTextAlignment > 2 or DayTimeMoneyHud.position[a].setTextAlignment < 0 then DayTimeMoneyHud.position[a].setTextAlignment = 0;end;
			--if a < 5 then
				if getXMLFloat(Xml, groupNameTag.. "#setPosX") then DayTimeMoneyHud.position[a].setPosX = getXMLFloat(Xml, groupNameTag.. "#setPosX");end;
				if getXMLFloat(Xml, groupNameTag.. "#setPosY") then DayTimeMoneyHud.position[a].setPosY = getXMLFloat(Xml, groupNameTag.. "#setPosY");end;
			--end;
		end;		
	end;	
end;

function DayTimeMoneyHud:getOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = defaultSize;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 0.0005;
			length = getTextWidth(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;
	end;
	return default;
end;

function DayTimeMoneyHud:getStringFormat(stringUnformat, position)
	local stringFormat = "";	
	function stringSplit(txtString, delimiter)
		  local result = {};
		  local from  = 1;
		  local delim_from, delim_to = string.find( txtString, delimiter, from  );
		  while delim_from do
			table.insert( result, string.sub( txtString, from , delim_from-1 ) );
			from  = delim_to + 1;
			delim_from, delim_to = string.find( txtString, delimiter, from  );
		  end
		  table.insert( result, string.sub( txtString, from  ) );
		  return result;
		end
	function internSetString(tempStringSplit, position)
		if string.find(string.lower(tempStringSplit), "freetxt_") then			
			local tempString = string.gsub(tempStringSplit, "freetxt_", "");			
			stringFormat = stringFormat.. tostring(tempString);
		elseif string.find(string.lower(tempStringSplit), "rhms") then
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud:getRealTime(true, true, true));
		elseif string.find(string.lower(tempStringSplit), "rhm") then
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud:getRealTime(true, true, false));
		elseif string.find(string.lower(tempStringSplit), "rhour") then
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud:getRealTime(true, false, false));
		elseif string.find(string.lower(tempStringSplit), "rmin") then
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud:getRealTime(false, true, false));
		elseif string.find(string.lower(tempStringSplit), "rsec") then
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud:getRealTime(false, false, true));	
		elseif string.find(string.lower(tempStringSplit), "rday") then
			local tempString = DayTimeMoneyHud:getRealDay(true, false, false, false);
			stringFormat = stringFormat.. tostring(tempString);
		elseif string.find(string.lower(tempStringSplit), "rweekday") then
			local tempString = DayTimeMoneyHud:getRealDay(false, true, false, false);			
			if tonumber(tempString) == 0 then tempString = 7;end;
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud.language.weekday[tonumber(tempString)]);			
		elseif string.find(string.lower(tempStringSplit), "rmonth") then			
			local tempString = DayTimeMoneyHud:getRealDay(false, false, true, false);			
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud.language.month[tonumber(tempString)]);
		elseif string.find(string.lower(tempStringSplit), "ryear") then
			local tempString = DayTimeMoneyHud:getRealDay(false, false, false, true);
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud.language.year[tonumber(tempString)]);
		elseif string.find(string.lower(tempStringSplit), "iplayday") then
			local tempString = DayTimeMoneyHud:getInGameDay(true, false);
			--stringFormat = stringFormat.. tostring(DayTimeMoneyHud.language.other[1].. tempString);	
			stringFormat = stringFormat.. tostring(tempString);	
		elseif string.find(string.lower(tempStringSplit), "iweekday") then
			local tempString = DayTimeMoneyHud:getInGameDay(false, true);
			if tonumber(tempString) == 0 then tempString = 7;end;
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud.language.weekday[tonumber(tempString)]);
		elseif string.find(string.lower(tempStringSplit), "langother") then
			local tempString = string.gsub(tempStringSplit, "langother", "");
			stringFormat = stringFormat.. tostring(DayTimeMoneyHud.language.other[tonumber(tempString)])
		elseif string.find(string.lower(tempStringSplit), "iplaytime") then
			--later
		elseif string.find(string.lower(tempStringSplit), "imoney") then
			--later
		elseif string.find(string.lower(tempStringSplit), "ihelperonoff") then
			--later
			elseif string.find(string.lower(tempStringSplit), "ihelperon") then			
			--later	
		elseif string.find(string.lower(tempStringSplit), "ihelperoff") then
			--later	
		elseif string.find(string.lower(tempStringSplit), "iforwardtime") then
			local tempString = Utils.getNoNil(g_currentMission.missionInfo.timeScale, 1);
			--stringFormat = stringFormat.. tostring(DayTimeMoneyHud.language.other[4].. tempString);
			stringFormat = stringFormat.. tostring(tempString);
			if tonumber(tempString) > 1 then
				DayTimeMoneyHud.foundForwardTimeString = position;
			else
				DayTimeMoneyHud.foundForwardTimeString = 0;
			end;
		else
			stringFormat = stringFormat.. tostring(tempStringSplit);
		end;	
	end;
	local typeString = stringSplit(stringUnformat, ","); --Utils.splitString(",", stringUnformat) not ready at LS19;	
	if typeString ~= nil and #typeString > 0 then
		for a = 1, #typeString do
			if typeString[a] ~= nil then
				local tempStringSplit = typeString[a];
				internSetString(tempStringSplit, position);
			else
				internSetString(stringUnformat, position);
			end;
		end;
	else
		internSetString(stringUnformat, position);
	end;
	return stringFormat;
end;

function DayTimeMoneyHud:getRealDay(day, weekday, month, year)
	if day and not weekday and not month and not year then return getDate("%d");end;
	if weekday and not day and not month and not year then return getDate("%w");end; --math.mod(getDate("%w"), 7);end;
	if month and not day and not weekday and not year then return getDate("%m");end;
	if year and not day and not weekday and not month then return getDate("%Y");end;
	
	if weekday and day and month and not year then return getDate("%w"), getDate("%d"), getDate("%m");end;
	if weekday and day and month and year then return getDate("%w"), getDate("%d"), getDate("%m"), getDate("%Y");end;
	return 1, 1, 1, 1;
end;

function DayTimeMoneyHud:getRealTime(getHours, getMin, getSec)
	if DayTimeMoneyHud.timeFormat > 12 then 
		if getHours and not getMin and not getSec then return tostring(getDate("%H"));end;
		if not getHours and getMin and not getSec then return tostring(getDate("%M"));end;
		if not getHours and not getMin and getSec then return tostring(getDate("%S"));end;
		if getHours and getMin and not getSec then return tostring(getDate("%H:%M"));end;
		if getHours and getMin and getSec then return tostring(getDate("%H:%M:%S"));end;
	elseif DayTimeMoneyHud.timeFormat <= 12 then
		if getHours and not getMin and not getSec then return tostring(getDate("%I")).. string.lower(getDate("%p"));end;
		if not getHours and getMin and not getSec then return tostring(getDate("%M")).. string.lower(getDate("%p"));end;
		if not getHours and not getMin and getSec then return tostring(getDate("%S")).. string.lower(getDate("%p"));end;
		if getHours and getMin and not getSec then return tostring(getDate("%I:%M")).. string.lower(getDate("%p"));end;
		if getHours and getMin and getSec then return tostring(getDate("%I:%M:%S")).. string.lower(getDate("%p"));end;
	end;
	return "0";
end;

function DayTimeMoneyHud:getInGameDay(currentDay, weekday)	
	local tempCurrentDay = 1;
	--Sicherheitsabfrage bei inGameDay Error bei einigen Usern
	if g_currentMission ~= nil and g_currentMission.environment ~= nil and g_currentMission.environment.currentDay ~= nil then tempCurrentDay = g_currentMission.environment.currentDay;
	elseif g_currentMission ~= nil and g_currentMission.missionInfo ~= nil and g_currentMission.missionInfo.currentDay ~= nil then tempCurrentDay = g_currentMission.missionInfo.currentDay;end;
	--Sicherheitsabfrage bei inGameDay Error bei einigen Usern
	if currentDay and not weekday then return tempCurrentDay;end;
	if not currentDay and weekday then return math.mod(tempCurrentDay, 7);end;
	if currentDay and weekday then return tempCurrentDay, math.mod(tempCurrentDay, 7);end;
	return 1, 1;
end;

function DayTimeMoneyHud:getInGameDisplay()
	for key, value in pairs(g_currentMission.hud.displayComponents) do
		if g_currentMission.hud.displayComponents[key].showTime ~= nil then
			DayTimeMoneyHud.inGame = g_currentMission.hud.displayComponents[key];
			break;
		end;
	end;
end;				